using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;

/// <summary>
/// лģ
/// 1.첽
/// 2.Э
/// 3.ί
/// </summary>
public class ScenesMgr : BaseManager<ScenesMgr> 
{
    /// <summary>
    /// лͬ
    /// </summary>
    /// <param name="name"></param>
    public void LoadScene(string name,UnityAction fun)
    {
        //ͬ
        SceneManager.LoadScene(name);
        //ɹ Żȥִfun
        fun();
    }

    /// <summary>
    /// 첽أṩⲿ
    /// </summary>
    /// <param name="name"></param>
    /// <param name="fun"></param>
    public void LoadSceneAsyn(string name,UnityAction fun)
    {
        //ͨmonoģ鿪Э̣ΪЭҪ̳mono
        MonoMgr.GetInstance().StartCoroutine(ReallyLoadSceneAsyn(name, fun));
    }

    /// <summary>
    /// Э첽س
    /// </summary>
    /// <param name="name"></param>
    /// <param name="fun"></param>
    /// <returns></returns>
    private IEnumerator ReallyLoadSceneAsyn(string name, UnityAction fun)
    {
       AsyncOperation ao = SceneManager.LoadSceneAsync(name);
        //ԵõصĽ
        while(!ao.isDone)
        {
            //¼ ַ  þ
            EventCenter.GetInstance().EvennTrigger("",ao.progress);
            //ȥ½
            yield return ao.progress;
        }
        
        
        //ɹ󣬲Żִfun
        fun();
    }

}
